c*****7*****************************************************************
	subroutine init_hpgl (filname)
c+
c	This is the device driver for HPGL plotters (HP7475 ..).
c
c	Version : 1.0
c	Date    : 11 Oct 96
c
c	Author  : Th. Proffen  (proffen@rsc.anu.edu.au)
c-
	implicit	none
c
	include		'kuplot.inc'
	include		'errlist.inc'
c
	character*(*)	filname
	integer		len_str
c
	call oeffne (99,filname,'unknown',.false.)
	if (ier_num.ne.0) return
c
	write (*,2000) filname(1:len_str(filname))
  	write (99,1000) char(27)//'.y'//char(27)//'.n;19:'
     &	              //char(27)//'.i;;17:'    
c
1000	format (1x,a)
2000	format (' ------ > Writing HPGL plot to file ',A,' ..')
	end
c*****7*****************************************************************
	subroutine open_hpgl 
c+
c	Init HPGL
c-
	implicit 	none
c
	include		'kuplot.inc'
c
	integer		hpgl_xmax,hpgl_ymax
c
	hpgl_xmax = 10000
	hpgl_ymax =  7200
c
	fakx     = (frame(iframe,3)-frame(iframe,1))* 
     &	            hpgl_xmax/(wxmax-wxmin)
	faky     = (frame(iframe,4)-frame(iframe,2))*
     &	            hpgl_ymax/(wymax-wymin)
	shiftx   = frame(iframe,1) * hpgl_xmax
	shifty   = frame(iframe,2) * hpgl_ymax
	xnull    = wxmin
	ynull    = wymin
c
	write (99,1005) hpgl_xmax,hpgl_ymax
	write (99,1000) 'ip603,121,10603,7321'
c
1000	format (1x,a)
1005	format (1x,'in;sc0,',i,',0,',i,';')
	end
c*****7*****************************************************************
	subroutine close_hpgl
c+
c	Close HPGL device
c-
	implicit	none
c
	write (99,1000) 'sp;'
	close (99)
c
1000	format (1x,a)
	end
c*****7*****************************************************************
	subroutine col_hpgl (icol) 
c+
c	set color
c-
	implicit	none
c
	integer		icol
c
	write (99,1010) icol
c
1010	format (1x,'sp',i1,';')
	end
c*****7*****************************************************************
	subroutine fsize_hpgl (fsize,fid) 
c+
c	set font and fontsize
c-
	implicit	none
c
	include		'kuplot.inc'
c
	real		fsize
	real		fak_lj,fak_lj_x,fak_lj_y
	real		hpgl_ch_x,hpgl_ch_y	
	integer		fid
c
	fak_lj_x  = (frame(iframe,3)-frame(iframe,1))
	fak_lj_y  = (frame(iframe,4)-frame(iframe,2))
	fak_lj    = (fak_lj_x+fak_lj_y)/2.
	hpgl_ch_x = fak_lj * fsize / 888.9
	hpgl_ch_y = fak_lj * fsize / 571.4
	charhx = 2.3 * hpgl_ch_x / plmass(iframe)
	charhy = 2.3 * hpgl_ch_y / (plmass(iframe)*yskal(iframe))
c
	write (99,1010) hpgl_ch_x,hpgl_ch_y
c
1010	format (1x,'si',f5.2,',',f5.2,';')
	end
c*****7*****************************************************************
	subroutine ltyp_hpgl (ityp,lwidth) 
c+
c	set line style
c-
	implicit	none
c
	real		lwidth
	integer		ityp
c
	if (ityp.eq.1) then
	  write (99,1020)
	else
	  write (99,1010) (ityp-1)*0.5
	endif
	write (99,1030) lwidth/3.4
c
1010	format (1x,'lt2,',f4.1,';')
1020	format (1x,'lt;')
1030	format (1x,'pw',f4.2,';')
	end
c*****7*****************************************************************
	subroutine text_hpgl (xp,yp,text,jmode)
c+
c	output text
c-
	implicit	none
c
	include		'kuplot.inc'
c
	character*(*)	text
	character*80	cdummy
	real		xp,yp
	integer		jmode,ix,iy,il
c
	integer		len_str
c
	cdummy=text
	il = len_str(cdummy)
	if (jmode.lt.0) then
	  write (99, 995)
	else
	  write (99, 999)
	endif
c
	if (abs(jmode).eq.if_left) then
	  xp=xp
	  yp=yp
	elseif (abs(jmode).eq.if_right) then
	  xp=xp-il*charhx
	  yp=yp
	elseif (abs(jmode).eq.if_centre) then
	  xp=xp-(il/2)*charhx
	  yp=yp
	endif
c
	ix = nint ((xp-xnull)*fakx+shiftx)	
	iy = nint ((yp-ynull)*faky+shifty)	
	write (99,1010) ix,iy
	write (99,1000) 'lb'//cdummy(1:il)//char(3)
c
 995	format (1x,'di0,1;')
 999	format (1x,'di;')
1000	format (1x,a)
1010	format (1x,'pu;pa',i5,',',i5,';')
	end
c*****7*****************************************************************
	subroutine pline_hpgl (npkt,xa,ya)
c+
c	polyline ..
c-
	implicit	none
c
	include		'kuplot.inc'
c
	integer		npkt,i,ix,iy
	real		xa(npkt),ya(npkt)
c
	ix = nint ((xa(1)-xnull)*fakx+shiftx)	
	iy = nint ((ya(1)-ynull)*faky+shifty)	
	write (99,1010) ix,iy
	do i=2,npkt
	  ix = nint ((xa(i)-xnull)*fakx+shiftx)	
	  iy = nint ((ya(i)-ynull)*faky+shifty)	
	  write (99,1020) ix,iy
	enddo
c
1010	format (1x,'pu;pa',i5,',',i5,';')
1020	format (1x,'pd;pa',i5,',',i5,';')
	end
c*****7*****************************************************************
	subroutine circ_hpgl (px,py,delx,dely,fill)
c+
c	circles ..
c-
	implicit	none
c
	include		'kuplot.inc'
c
	real		px,py,delx,dely
	integer		ix,iy,idx,idy
	logical		fill
c
	ix  = nint ((px-xnull)*fakx+shiftx)	
	iy  = nint ((py-ynull)*faky+shifty)
	idx = nint (delx*fakx)	
	idy = nint (dely*faky)
c
	if (fill) then
	  write (99,1010) ix,iy,idx
	else
	  write (99,1020) ix,iy,idx
	endif
c
1010	format (1x,'ft1;pu;pa',i5,',',i5,';pd;wg',i5,',0,360;')
1020	format (1x,'pu;pa',i5,',',i5,';pd;ci',i5,';')
	end
c*****7*****************************************************************
	subroutine rect_hpgl (xlu,ylu,xro,yro,fill)
c+
c	rectangles ..
c-
	implicit	none
c
	include		'kuplot.inc'
c
	real		xlu,ylu,xro,yro
	integer		ixlu,iylu,ixro,iyro
	logical		fill
c
	ixlu = nint ((xlu-xnull)*fakx+shiftx)	
	iylu = nint ((ylu-ynull)*faky+shifty)
	ixro = nint ((xro-xnull)*fakx+shiftx)	
	iyro = nint ((yro-ynull)*faky+shifty)
c
	if (fill) then
	  write (99,1010) ixlu,iylu,ixro,iyro
	else
	  write (99,1020) ixlu,iylu,ixro,iylu,ixro,iyro,ixlu,iyro,
     &	                  ixlu,iylu
	endif
c	
1010	format (1x,'ft1;pu;pa',i5,',',i5,';pd;ra',i5,',',i5,';')
1020	format (1x,'pu;pa',i5,',',i5,'pd;pa',7(i5,','),i5,';')
	end
c*****7*****************************************************************
	subroutine area_hpgl (npkt,xp,yp,fill)
c+
c	area borders ..
c-
	implicit	none
c
	include		'kuplot.inc'
c
	integer		npkt
	real		xp(npkt),yp(npkt)
	logical		fill
c
	integer		xi(4),yi(4),i
c
	do i=1,npkt
	  xi(i) = nint ((xp(i)-xnull)*fakx+shiftx)	
	  yi(i) = nint ((yp(i)-ynull)*faky+shifty)
	enddo
c
	if (fill) then
	  write (99,1010) (xi(i),yi(i),i=1,npkt),xi(1),yi(1)
	else
	  write (99,1020) (xi(i),yi(i),i=1,npkt),xi(1),yi(1)
	endif
c	
1010	format (1x,'ft1;pu;pa',i5,',',i5,'pd;pa',7(i5,','),i5,';')
1020	format (1x,'pu;pa',i5,',',i5,'pd;pa',7(i5,','),i5,';')
	end
